<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:variable name= "description" select="document('')//atlasDescription" />
<xsl:output method="xml" indent="yes"/> 

<atlas:data xmlns:atlas="urn:www.atlasti.com/xml/001">
<atlasDescription version = "1.0"> <!-- Version of this description syntax -->
<friendlyName>Expandable Boxes by Name</friendlyName> <!-- To be displayed in ATLAS.ti -->
<shortDescription>A list of codes and memos with a frame</shortDescription>
<comment>Creates a list report of codes and memos where each one with a comment can be collapsed or expanded. Sort order: name</comment>
<category>Viewer</category>
<complexity>low</complexity> <!-- Computational complexity -->
<iconPath>box.ico</iconPath> <!-- To be displayed in ATLAS.ti -->
<author name="Thomas Ringmayr" email="xml@support.atlasti.com" url="www.atlasti.com/xml.html"/>
<creationDate>2003-05-31</creationDate>
<sourceType type = "HU" version = "5.0"/> <!-- XML type acccepted as input -->
<targetDocType>HTML</targetDocType> 
</atlasDescription>
</atlas:data>

<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->

<xsl:param name="sortCrit">name</xsl:param>
<xsl:param name="ascdesc" >ascending</xsl:param>
<xsl:include href="boxsortrest.xsl.inc"/>

</xsl:stylesheet>