@echo off
rem ATLAS.ti support file
rem Replacing all atlas.ti files which cannot be installed during installation of a service pack
rem expects a multitude of 3 parameters: %1 the new file, %2 the name of the file to be replaced and %3 bu/nobu to optionally backup the existing file
rem Version 1.0 - May 2006
if not "%1" == "" goto start
echo *********************************************
echo * ATLAS.ti Servicepack Installation Support *
echo *********************************************
echo -
echo You need to run REPLACEFILES.BAT not _REPLACE.BAT!
pause
rem goto bad
:start

set logFile=..\updates.log
:LOOP
set currentFile=%2
set tempFile= __%currentFile%
if %3 == bu set backupFile= "backup of %currentFile%"
set newFile=%1

echo Replacing file "%currentFile%" with "%newFile%". >> %logFile%

if not exist %newFile% goto nonew

if not exist %currentFile% goto nocurrent
if not %3 == bu goto movecurrent
copy /y %currentFile% %backupFile%
echo Created backup %backupFile% of  "%currentFile%"
echo Created backup %backupFile% of  "%currentFile%" >> %logFile%
:movecurrent
move /y %currentFile% %tempFile%
if exist %currentFile% goto failedremovecurrent

:nocurrent
move /y %newFile% %currentFile%
if exist %newFile% goto failedrename
goto success

:failedrename
move /y %tempFile% %currentFile% 
echo Cannot rename file "%newFile%" to "%currentFile%". Make sure that ATLAS.ti is currently not running and that you have the rights to delete and rename files
echo Cannot rename file "%newFile%" to "%currentFile%". >> %logFile%
goto next

:failedremovecurrent
echo Cannot remove file "%currentFile%". Make sure that ATLAS.ti is currently not running and that you have the rights to delete files.
echo Cannot remove file "%currentFile%". >> %logFile%
goto next

:nonew
echo File not found: "%newFile%" >> %logFile%

if not exist %currentFile% goto next
rem we want to keep it if exist %tempFile% del %tempFile%
goto next

:success
if exist %tempFile% del %tempFile%
echo File "%currentFile%" was successfully installed.
echo File "%currentFile%" installed. >> %logFile%

:next
REM Get the next three commandline parameters of the caller
SHIFT 
SHIFT
SHIFT
IF "%1" == "" GOTO FINITO
GOTO LOOP

:FINITO
set currentFile=
set tempFile=
set newFile=
