<?xml version="1.0" encoding="UTF-8"?>
<!--
Display ATLAS.ti generated codes/memos sorted by creation date with comment/body in a box - 
Version 1.0 5.11.01
Copyright 2001 Scientific Software Development/Thomas Muhr
Revision 200205 by ringmayr interNet | hyperMedia consulting + development
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:variable name= "description" select="document('')//atlasDescription" />
<xsl:output method="xml" indent="yes"/> 

<atlas:data xmlns:atlas="urn:www.atlasti.com/xml/001">
<atlasDescription version = "1.0"> <!-- Version of this description syntax -->
  <friendlyName>Expandable Boxes by Date</friendlyName> <!-- To be displayed in ATLAS.ti -->
  <shortDescription>A list of codes and memos with a frame</shortDescription>
  <comment>Creates a list report of codes and memos where each 
one with a comment can be collapsed or expanded. 
Sort order: creation date</comment>
  <category>Viewer</category>
  <complexity>low</complexity> <!-- Computational complexity -->
  <iconPath>box.ico</iconPath> <!-- To be displayed in ATLAS.ti -->
  <author name="Thomas Muhr" email="Infoline@atlasti.de" url="www.atlasti.com/downloads/stylesheets/"/>
  <creationDate>2003-05-31</creationDate>
  <sourceType type = "HU" version = "5.0"/> <!-- XML type acccepted as input -->
  <targetDocType>HTML</targetDocType> 
</atlasDescription>
</atlas:data>
<!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->

<xsl:param name="sortCrit">cDate</xsl:param>
<xsl:param name="ascdesc" >descending</xsl:param>
<xsl:include href="boxsortrest.xsl.inc"/>

</xsl:stylesheet>